;  alt2:
; 09-11-2005    
; 09-11-2005    
; 09-11-2005  longdelay
; 12-11-2005 :  32    

; alt3:
;    62500  125 
; -     32  64
;  -     ,    -  

; alt4:
;    PORTC1

; alt5:
;       PORTC0  PORTC1,  

; alt7:
;   , g-sw   
;     PORTC1
;     Timer2    330 
;    17 (3)  Timer2
;       PORTC1  PORTC0,  ,   

;alt7-1
;     :    .
;   
;      
;
;



; :
; r0 -
; r1 .def T1      = r1
; r2 .def T2      = r2
; r3 fpconv10a: mov R3,rmp
; r4 fpconv10a: mov R4,rmp
; r5 UART_send:
; r6
; r7 UART_send:
; r8 UART_send:
; r9 UART_send:
; r10 .def tmp1 = r10
; r11 -
; r12 -
; r13 -
; r14 -
; r15 ; Shut delay flag g_sw:
; r16 .def tmp  = r16
; r17 .def max_mem = r17
; r18 .def rmp = r18
; r19 ; Shut delay flag minus: plus: shut:
; r20 .def Shut = r20
; r21 ; Shut delay flag minus: plus: shut:
; r22 .def empty_again = r22
; r23 ; Shut delay flag
; r24 ; Shut delay flag
; r25    



.include "C:\vmlab\include\m8def.inc"

.def T1      = r1
.def T2      = r2
.def tmp1 = r10
;---------------------------------------------------;
.def tmp  = r16
.def max_mem = r17
.def rmp = r18

.def Shut = r20
.def empty_again = r22
.equ UBRRVAL = 25
.equ	BLOCK1	=$60		;start address of SRAM array #1

reset:
rjmp start
reti      ; Addr $01
reti      ; Addr $02
reti      ; Addr $03
reti      ; Addr $04
reti      ; Addr $05
reti      ; Addr $06        Use 'rjmp myVector'
reti      ; Addr $07        to define a interrupt vector
reti      ; Addr $08
rjmp timer0    ; Timer 0
reti      ; Addr $0A
reti      ; Addr $0B        This is just an example
reti      ; Addr $0C        Not all MCUs have the same
reti      ; Addr $0D        number of interrupt vectors
rjmp adc_action    ; Addr $0E    !!!!!!!!!!!!
reti      ; Addr $0F
reti      ; Addr $10

; Program starts here after Reset

start:

	ldi r16, low(RAMEND);
   out SPL, r16
   ldi r16, high(RAMEND)
   out SPH, r16

		; USART Baudrat SETUP
  	ldi tmp, LOW(UBRRVAL)
	out UBRRL, tmp
	ldi tmp, HIGH(UBRRVAL)
	out UBRRH, tmp
; USART
	ldi tmp, (1<<URSEL)|(3<<UCSZ0)
	out UCSRC, tmp

;    0
   ldi tmp,0b00000001
	out TIMSK,tmp

	ldi	tmp,0b1111 ;PB1 inputs others outputs
	out	DDRB,tmp
	ldi	tmp,0b001
	out	PORTB,tmp	;Enable pullup resistors on PORT A

	ldi	tmp,0b1110
	out	DDRC,tmp
	ldi	tmp,0b0000
	out	PORTC,tmp	;Enable pullup resistors on PORT A
	
	ldi	tmp,0b11011111 ;
	out	DDRD,tmp
	ldi	tmp,0b01111010
	out	PORTD,tmp	;Enable pullup resistors on PORT A
	
	
	; Enable sleep mode, select falling edge
	ldi tmp, 0xA0
   out MCUCR,tmp
	
	; Set up mem addr
	ldi XH,0x00
	ldi XL,0x60

	clr ZH
	clr ZL

	clr YH
	clr YL
		
   ; set max mem addr
	ldi max_mem,0x9E

;  wakeup2,  PIND,5 
   sbis PIND,5
   rcall wakeup2	

;Timer 0
	ldi tmp,(1<<CS02);|(1<<CS00)
   out TCCR0,tmp ; Timer clock = system clock / 256
   ;   0  255,    61.035   

;Timer 2
	ldi tmp,(1<<WGM21)|(1<<COM20)|(1<<CS21)|(1<<CS20)
;1<<WGM21     
;1<<COM20   2 (17, 3)   
;1<<CS21      4 ,   8
   out TCCR2,tmp
	ldi tmp, 35
	out OCR2,tmp

   clr R20
   clr R10

   ; ADC activation
;	ldi tmp,(1<<MUX0) ;    PORTC1
;	out ADMUX,tmp

	ldi tmp,(1<<ADEN)|(1<<ADSC)|(1<<ADFR)|(1<<ADIE)|(1<<ADPS2)|(0<<ADPS1)|(1<<ADPS0)
	;(1<<ADEN)  
	;(1<<ADSC) 1- 
	;(1<<ADFR) 1-  

	;(1<<ADPS2)   32
	;(0<<ADPS1)    4      125000 .
	;(1<<ADPS0)     13 ,   9615.4   .

   ;(1<<ADIE)    
	out ADCSR,tmp

   clr R19
   clr R15
   clr R20
 	clr r21
	clr R22
   clr R23
	clr R24

	ldi R25,64 ;  ,       

   rcall longDelay
cbi portb,0
;Set Global Interrupt Flag
	sei	

forever:
rjmp forever

;=================================================
adc_action:
cpi r25,64
breq end_adc

in r11,ADCL
in r12,ADCH
add tmp,r11
adc tmp1,r12

inc r25

end_adc:
reti

;=================================================
timer0:

clr r25
clr tmp
clr tmp1

sei
wait_adc:
; Compare branch if nonEqual
cpi r25,64
brne wait_adc

st X+,tmp1
st X+,tmp

;  ,  XL = max_mem
cpse XL,max_mem
reti

;mov R20,tmp

st X+,tmp1
st X+,tmp

rcall MASTER_TX

mov r16, YH
;Compare with Immediate
cpi r16, 2 ;
;Branch if registers r16, 2 equal
breq goto_sleep

reti
;  timer0: ------------------------------------

;==================================================
write_too_mem:

EEPROM_write:
; Wait for completion of previous write

;Skip if Bit in I/O Register is Cleared
sbic EECR,EEWE
rjmp EEPROM_write
; Set up address  in address register
out EEARH, XH
out EEARL, XL
;Add Immediate to Word
adiw XL,0x01
out EEDR,tmp
; Write logical one to EEMWE
;Set Bit in I/O Register
sbi EECR,EEMWE
; Start eeprom write by setting EEWE
;Set Bit in I/O Register
sbi EECR,EEWE
ret
;  EEPROM_write: ------------------------------------


;==================================================
goto_sleep:

sbi portb,0

ldi tmp,1<<TCNT0
out TCNT0,tmp ;
ldi tmp,0b000
out TCCR0,tmp ; Timer clock = system clock / 1024
ldi tmp,0<<TOIE0
out TIMSK,tmp ; DISABLE Timer/Counter0 Overflow Interrupt

clr tmp
out ADCSR,tmp

;Clear Bit in I/O Register
cbi UCSRB,TXEN                    ; TX aktivieren
;Enable exeternal interrupts, that will wake up from sleep mode
ldi tmp, 0xC0
out GICR, tmp

;clr tmp
;out DDRB,tmp
;Clear Global Interrupt Flag
cli

ENDMIG:
   sbi PORTB,0
	rcall _delay01sec
   cbi PORTB,0
	rcall _delay1sec
	rjmp ENDMIG
;sleep
ret
;  goto_sleep: ------------------------------------
;==================================================
wakeup:

ld R2,X+ ; 
ld R1,X+ ; 

;----------------------------------------------------------------
      ldi tmp,$00
		cp r1,tmp   ;    
		brne M_0
      inc r1        ; Increase r1
M_0:

      ldi tmp,$01
		cp r1,tmp   ;    1
		brne M_1
      inc r1        ; Increase r1
M_1:
;----------------------------------------------------------------

UART_send:
sbis UCSRA,UDRE
rjmp UART_send
out UDR,R1

UART_send2:
sbis UCSRA,UDRE
rjmp UART_send2
out UDR,R2

; Compare Skip if Equal
cpse XL,max_mem
rjmp wakeup
ret
reti
;  wakeup: ------------------------------------

;==================================================
EEPROM_read:
; Wait for completion of previous write
sbic EECR,EEWE
rjmp EEPROM_read
out EEARH, XH
out EEARL, XL
; Start eeprom read by writing EERE
sbi EECR,EERE
; Read data from Data Register
in R2,EEDR
adiw XL,0x01

EEPROM_read1:
; Wait for completion of previous write
sbic EECR,EEWE
rjmp EEPROM_read1
out EEARH, XH
out EEARL, XL
; Start eeprom read by writing EERE
sbi EECR,EERE
; Read data from Data Register
in R1,EEDR
adiw XL,0x01
ret
;  EEPROM_read: ------------------------------------


longDelay:
;1111111111111111111111111
   ldi tmp,200
	clr   T1		;T1 used as delay 2nd count
	clr   T2		;T2 used as delay 3d count
delay_1:
;Decrement
	dec   T2
;Branch if Not Equal
	brne  delay_1
	dec   T1
	brne  delay_1
	sbrs  tmp,2    ; Skip if bit 2 set
   sbi PORTB,0    ; Only executed if bit 2 not set
   sbrc tmp,2            ; Skip if bit 2 cleared
   cbi PORTB,0      ; Only executed if bit 2 not cleared
	dec   tmp		;temp must be preset as
	brne  delay_1		; delay master count

;22222222222222222222222222222222
   ldi tmp,200
	clr   T1		;T1 used as delay 2nd count
	clr   T2		;T2 used as delay 3d count
delay_2:
;Decrement
	dec   T2
;Branch if Not Equal
	brne  delay_2
	dec   T1
	brne  delay_2
	sbrs  tmp,2    ; Skip if bit 2 set
   sbi PORTB,0    ; Only executed if bit 2 not set
   sbrc tmp,2            ; Skip if bit 2 cleared
   cbi PORTB,0      ; Only executed if bit 2 not cleared
	dec   tmp		;temp must be preset as
	brne  delay_2		; delay master count
;333333333333333333333333333333333
   ldi tmp,200
	clr   T1		;T1 used as delay 2nd count
	clr   T2		;T2 used as delay 3d count
delay_3:
;Decrement
	dec   T2
;Branch if Not Equal
	brne  delay_3
	dec   T1
	brne  delay_3
	sbrs  tmp,2    ; Skip if bit 2 set
   sbi PORTB,0    ; Only executed if bit 2 not set
   sbrc tmp,2            ; Skip if bit 2 cleared
   cbi PORTB,0      ; Only executed if bit 2 not cleared
	dec   tmp		;temp must be preset as
	brne  delay_3		; delay master count
;4444444444444444444444444444444444444
   ldi tmp,200
	clr   T1		;T1 used as delay 2nd count
	clr   T2		;T2 used as delay 3d count
delay_4:
;Decrement
	dec   T2
;Branch if Not Equal
	brne  delay_4
	dec   T1
	brne  delay_4
	sbrs  tmp,2    ; Skip if bit 2 set
   sbi PORTB,0    ; Only executed if bit 2 not set
   sbrc tmp,2            ; Skip if bit 2 cleared
   cbi PORTB,0      ; Only executed if bit 2 not cleared
	dec   tmp		;temp must be preset as
	brne  delay_4		; delay master count

ret


;==================================================
_delay1sec:
;1111111111111111111111111
   ldi tmp,25
	clr   T1		;T1 used as delay 2nd count
	clr   T2		;T2 used as delay 3d count
delay_11:
;Decrement
	dec   T2
;Branch if Not Equal
	brne  delay_11
	dec   T1
	brne  delay_11
	dec   tmp		;temp must be preset as
	brne  delay_11		; delay master count

ret

;==================================================
_delay01sec:
;1111111111111111111111111
   ldi tmp,3
	clr   T1		;T1 used as delay 2nd count
	clr   T2		;T2 used as delay 3d count
delay_01:
;Decrement
	dec   T2
;Branch if Not Equal
	brne  delay_01
	dec   T1
	brne  delay_01
	dec   tmp		;temp must be preset as
	brne  delay_01		; delay master count

ret

;==================================================

MASTER_TX:

   cli   ; Interrupts not used; must poll TWINT bit

; Set bitrate for master mode
; ---------------------------
   ldi r16, 10    ; Minimum value must be 10 !
   out TWBR, r16  ; See formula in Atmel manual

; Send start and wait for TWINT flag
; ----------------------------------
   ldi r16, (1<<TWINT) | (1<<TWSTA) | (1<<TWEN)
   out TWCR, r16
   rcall wait_twint

; Load SLA + W and clear int flag
; -------------------------------
   ldi r16, 0xA0  ; Address = 0x1E, Write (TX)
   out TWDR, r16
   ldi r16, (1<<TWINT) | (1<<TWEN)
   out TWCR, r16
   rcall wait_twint

;   in r16, TWSR
;   andi r16, 0xF8
;   cpi r16, 0x18 ; Status code must be 0x18
;   brne ERROR

;   in R16,TWSR
;   rcall write_too_mem

   mov r16, ZH
   out TWDR, r16
   ldi r16, (1<<TWINT) | (1<<TWEN)
   out TWCR, r16
   rcall wait_twint

;   in R16,TWSR
;   rcall write_too_mem

   mov r16, ZL
   out TWDR, r16
   ldi r16, (1<<TWINT) | (1<<TWEN)
   out TWCR, r16
   rcall wait_twint

;   in R16,TWSR
;   rcall write_too_mem
; Check TWI Status register
; -------------------------
   in r16, TWSR
   andi r16, 0xF8
   cpi r16, 0x28 ; Status code must be 0x18
  ; brne ERROR

   clr XL
   clr XH
   ldi r18, 0x40
   ldi XL,0x60
   ldi XH,0x00
write_loop:

; Load data into TWDR register
; ----------------------------
;   rcall EEPROM_read1
   ld  R1,X+
	out TWDR, r1
   ldi r16, (1<<TWINT)|(1<<TWEN)
   out TWCR, r16
   rcall wait_twint    ; Wait for completion

; Check TWI Status register
; -------------------------
;   in r16, TWSR
;   andi r16, 0xF8
;   cpi r16, 0x28 ; Value must be 0x28
;  brne ERROR

  dec r18          ; Decrement data for
  brne write_loop  ; next cycle

; Send STOP and return
; --------------------
   ldi r16, (1<<TWINT) | (1<<TWEN) | (1<<TWSTO)
   out TWCR, r16

adiw ZH:ZL,1
adiw ZH:ZL,63
ldi XL,0x60
clr XH
adiw YH:YL,1

ret
;  MASTER_TX: ------------------------------------



; *********************************************
; Error processing. TWI provides a status
; code, upon the completion of any operation
;
ERROR:
   ldi tmp,(1<<DDB0)
	out DDRB,tmp
   nop       ; Some error: not acknowledge, etc.
   nop       ; Process it here.
   nop       ;
   rjmp ERROR


; **********************************************
; Wait for TWI operation, by polling TWINT flag
;
wait_twint:
   in r16, TWCR
   sbrs r16, TWINT
   rjmp wait_twint
   ret


;==================================================
MASTER_RX:
   cli   ; Interrupts not used; must poll TWINT bit

; Set bitrate for master mode
; ---------------------------
   ldi r16, 10    ; Minimum value must be 10 !
   out TWBR, r16  ; See formula in Atmel manual

; Send start and wait for TWINT flag
; -----------------------------------
   ldi r16, (1<<TWINT)|(1<<TWSTA)|(1<<TWEN)
   out TWCR, r16
   rcall wait_twint
  ; in R16,TWSR
  ; rcall write_too_mem

; Load SLA + R  and clear int flag
; --------------------------------
   ldi r16, 0xA0 ; Slave address = 0x1D; 1 = Read (RX)
   out TWDR, r16
   ldi r16, (1<<TWINT)|(1<<TWEN)
   out TWCR, r16
   rcall wait_twint

   mov r16, ZH
   out TWDR, r16
   ldi r16, (1<<TWINT) | (1<<TWEN)
   out TWCR, r16
   rcall wait_twint

   mov r16, ZL
   out TWDR, r16
   ldi r16, (1<<TWINT) | (1<<TWEN)
   out TWCR, r16
   rcall wait_twint

   ldi r16, (1<<TWINT)|(1<<TWSTA)|(1<<TWEN)
   out TWCR, r16
   rcall wait_twint

   ldi r16, 0xA1 ; Slave address = 0x1D; 1 = Read (RX)
   out TWDR, r16
   ldi r16, (1<<TWINT)|(1<<TWEN)
   out TWCR, r16
   rcall wait_twint

   ldi r16, (1<<TWINT)|(1<<TWEN)|(1<<TWEA) ; Enable aknowledge
   out TWCR, r16
; Read loop for 7 bytes
; ---------------------


ldi r18, 0x40
read_loop:             ;
   rcall wait_twint    ; Wait for completion
   in tmp,TWDR        ; Read received byte
;   clr r16
;   in R16,TWSR
;   rcall write_too_mem
   st X+,tmp

   ldi r16, (1<<TWINT)|(1<<TWEN)|(1<<TWEA) ; Enable aknowledge
   out TWCR, r16
   ;in R16,TWSR
   ;rcall write_too_mem
   dec r18
   ;adiw XL,0x01
   ;cpse ZH,max_memZ
   brne read_loop

   ldi r16, (1<<TWEN)  ; Disable aknowledge for last byte
   out TWCR, r16
   rcall wait_twint    ;

; Send STOP and return
; --------------------
   ldi r16, (1<<TWINT)|(1<<TWEN)|(1<<TWSTO)
   out TWCR, r16
   ret
;  MASTER_RX: ------------------------------------


;==================================================
wakeup2:
   ldi max_mem,0xA0
;Set Bit in I/O Register
	sbi UCSRB,TXEN                    ; TX aktivieren

   ldi XL,0x60
   clr XH
   rcall MASTER_RX
   ldi XL,0x60
   clr XH
   rcall wakeup
;Add Immediate to Word
   adiw ZH:ZL,1
   adiw ZH:ZL,63
   adiw YH:YL,1
   mov r16, YH
;Compare with Immediate
   cpi r16, 2
;Branch if Equal
   breq goto_sleep2
   rjmp wakeup2
goto_sleep2:
rcall goto_sleep
ret
;  wakeup2: ------------------------------------







































